Subject: Re: linux-next: build failure after merge of the rdma tree

From: Leon Romanovsky <[email-masked]>
Date: Tue, 9 Jul 2019 07:18:00 +0000

On Tue, Jul 09, 2019 at 10:04:16AM +0300, Mark Zhang wrote:
> Hi Stephen,

Stephen,

For some reason, I wasn't in initial email report, can you please check why?

I need to be aware of any issues related to patches with my name on it
for tracking and improving internal submission flows/checks.

>
> Can you please try the patch below, thank you.

Jason, Doug,

Can you please take this patch?

Thanks

>
> net/mlx5: Remove include ib_verbs.h in rdma_counter.h
>
> rdma_counter.h include ib_verbs.h which in turn needs rdma_port_counter
> from rdma_counter.h, but it is not defined yet.
>
> Fixes: 413d3347503b ("RDMA/counter: Add set/clear per-port auto mode
> support")
> Signed-off-by: Mark Zhang <[email-masked]>
>
> diff --git a/include/rdma/rdma_counter.h b/include/rdma/rdma_counter.h
> index 68827700ba95..eb99856e8b30 100644
> --- a/include/rdma/rdma_counter.h
> +++ b/include/rdma/rdma_counter.h
> @@ -9,10 +9,10 @@
>   #include <linux/mutex.h>
>   #include <linux/pid_namespace.h>
>
> -#include <rdma/ib_verbs.h>
>   #include <rdma/restrack.h>
>   #include <rdma/rdma_netlink.h>
>
> +struct ib_device;
>   struct ib_qp;
>
>   struct auto_mode_param {
>
> On 7/9/2019 11:30 AM, Stephen Rothwell wrote:
> > Hi all,
> >
> > After merging the rdma tree, today's linux-next build (x86_64
> > allmodconfig) failed like this:
> >
> > In file included from /home/sfr/next/next/include/rdma/rdma_counter.h:12,
> >                   from <command-line>:
> > /home/sfr/next/next/include/rdma/ib_verbs.h:2126:27: error: field 'port_counter' has incomplete type
> >    struct rdma_port_counter port_counter;
> >                             ^~~~~~~~~~~~
> >
> > Caused by commit
> >
> >    413d3347503b ("RDMA/counter: Add set/clear per-port auto mode support")
> >
> > rdma_counter.h include ib_verbs.h which in turn needs rdma_port_counter
> > from rdma_counter.h, but it is not defined yet :-(
> >
> > I have applied the following patch for today.
> >
> > From: Stephen Rothwell <[email-masked]>
> > Date: Tue, 9 Jul 2019 13:17:49 +1000
> > Subject: [PATCH] RDMA: don't try to build rdma_counter.h for now
> >
> > rdma_counter.h include ib_verbs.h which in turn needs rdma_port_counter
> > from rdma_counter.h, but it is not defined yet :-(
> >
> > Signed-off-by: Stephen Rothwell <[email-masked]>
> > ---
> >   include/Kbuild | 1 +
> >   1 file changed, 1 insertion(+)
> >
> > diff --git a/include/Kbuild b/include/Kbuild
> > index 78434c59701f..8dab85cdf4f4 100644
> > --- a/include/Kbuild
> > +++ b/include/Kbuild
> > @@ -939,6 +939,7 @@ header-test-			+= rdma/ib.h
> >   header-test-			+= rdma/iw_portmap.h
> >   header-test-			+= rdma/opa_port_info.h
> >   header-test-			+= rdma/rdmavt_cq.h
> > +header-test-			+= rdma/rdma_counter.h
> >   header-test-			+= rdma/restrack.h
> >   header-test-			+= rdma/signature.h
> >   header-test-			+= rdma/tid_rdma_defs.h
> >
>